//? cpmv.cpp
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#include <cpmv.h>

using CpmRoot::Z;
using CpmRoot::Word;
using CpmArrays::V;
using CpmArrays::IvZ;

Z CpmArrays::dimMax=100000000;
bool CpmArrays::ranChc=true;
bool CpmArrays::ranChcAlw=true;
bool CpmArrays::signal=false;

void CpmArrays::setDimMax(Z n)
{
   if (n<0)
      cpmerror(cpmwrite(n)&" not OK as value for CpmArrays::dimMax");
   dimMax=n;
}

Z CpmArrays::safeDim(Z n)
{
   if (n<0 || n>dimMax)
      cpmerror(cpmwrite(n)&" not OK as dimension of CpmArrays::V<>");
   return n;
}

V<Z> CpmArrays::IvZtoVofZ(IvZ const& iv)
{
   Z n=iv.car();
   V<Z> res(n);
   if (n==0) return res;
   Z i,val=iv.inf();
   for (i=res.b();i<=res.e();++i) res[i]=val++;
   return res;
}

V<Z> CpmArrays::VofIvZtoVofZ(V<IvZ> const& viv)
{
   V<Z> res(0);
   for (Z i=viv.b();i<=viv.e();++i) res&=IvZtoVofZ(viv[i]);
   return res;
}

V<Word> CpmArrays::comLine(int argc, char* argv[])
{
   V<Word> res(argc);
   for (Z i=res.b();i<=res.e();i++) res[i]=argv[i-1];
   return res;
}
