//? cpmcamera.h
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_CAMERA_H_
#define CPM_CAMERA_H_
/*

Description: Visualisation tool for 2D and 3D

*/

#include <cpmdim.h>
#include <cpmgraph.h>
#include <cpmimagingtools.h>
#include <cpmvectorgraphics.h>
#include <cpmrecordhandler.h>

namespace CpmColCam{  // collection of names relevant for cameras
   using CpmImaging::STEREOLEFT;
   using CpmImaging::STEREORIGHT;
   using CpmImaging::STEREOBLACK;
   using CpmImaging::STEREO;
   using CpmImaging::INVISIBLE;
   using CpmImaging::BLACK;
   using CpmImaging::WHITE;
   using CpmImaging::Color;
   using CpmGraphics::Frame;
   using CpmGraphics::Graph;
   using CpmGraphics::SitRec;
   using CpmGraphics::LOW;
   using CpmGraphics::UPP;
   using CpmGraphics::LEFT;
   using CpmGraphics::RIG;
   using CpmRootX::RecordHandler;
}

using CpmArrays::X2;

#include <cpmcamera2.h>
#include <cpmcamera3.h>

#endif
