//? cpmlogic1.cpp
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#include <cpmlogic1.h>

using namespace CpmMathFound;

Z Prop::count_=1;

Z Prop::com(const Type& p)const
{ 
   if (i_<p.i_) return 1;
   else if (i_>p.i_) return -1;
   else return 0;
}

bool Prop::prnOn(ostream& str)const
   { return b_.prnOn(str)&&i_.prnOn(str); }
   
bool Prop::scanFrom(istream& str)
   { return b_.scanFrom(str)&&i_.scanFrom(str);}

void V_bool::next()
{
   Z mesLim=4;
   if (cpmverbose>=mesLim) cpmmessage("V_bool::next() started");
   Z act=dim()-1;
// notice that rep is an instance of Vl<bool>   
Label:
   if ((*this)[act]==false){
      (*this)[act]=true;
      return;
   }
   else{
      (*this)[act]=false; 
      act--;
      if (act>=0) goto Label; else return;
   }
}

bool V_bool::end()const
{
   Z n=(*this).dim();
   for (Z i=0;i<n;i++){
      if ((*this)[i]==false) return false;
   }
   // then no rep[i] was found to be false
   return true;
}

