//? cpmmathfound.cpp
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#include <cpmmathfound.h>

using CpmMathFound::NatNum;
using CpmRoot::Z;
using namespace std;

NatNum unit();

Z NatNum::com(const NatNum& n)const
{
   if (rep.size()<n.rep.size())   return 1;
   if (rep.size()>n.rep.size())   return -1;
   return 0;
}

bool NatNum::prnOn(ostream& out)const
{
   CpmRoot::writeTitle("NatNum",out);
   CpmRoot::write(rep,out);
   return (out.good());
}

bool NatNum::scanFrom(istream& in)
{
   CpmRoot::read(rep,in);
   return (in.good());
}

NatNum NatNum::prev()const
{
   if (isUnit()) return *this;
   else{
      string repNew=rep;
      repNew.erase(rep.size()-2,1);
      return NatNum(repNew,true);
   }
}

NatNum NatNum::operator +(const NatNum& n)const
// concatenation '+' in class string is the basic 'arithmetic
// operation.
{
   return NatNum(rep+n.rep,true);
}

NatNum NatNum::operator *(const NatNum& n)const
// no direct usage of string features; only
// NatNum::isUnit(), NatNum::prev(), NatNum::+=()
{
   NatNum res=n;
   NatNum counter=*this;
   while (!counter.isUnit()){
      counter=counter.prev();
      res+=n;
   }
   return res;
}
