//? cpmactionprinciple.h
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_ACTION_PRINCIPLE_H_
#define CPM_ACTION_PRINCIPLE_H_
/*
   Studies the mid state variation of the action integral
   by numerical methods. This is intended to complement
   my symbolic studies based on Mathematica
   See mid-state-variation3j.nb of 2006-06-22
*/
#include <cpminifilebasapp.h>

namespace CpmPalaAction{ // devoted to the study of the action principle
/////////////////// class ActionPrinciple //////////////////////////////
   using CpmApplication::IniFileBasedApplication;
   using CpmRoot::Word;
      
class ActionAppl: public IniFileBasedApplication { // action application
   // This will deal only with the 3D case and thus allows a simple 
   // file structure. All relevant code is in cpmactionprinciple.cpp

public:
   ActionAppl(Word const& w);
   void doTheWork();
};

} // CpmPalaAction

#endif
