//? cpmextractor.h
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef CPM_EXTRACTOR_H_
#define CPM_EXTRACTOR_H_
/*

   Description: declares class Extractor
   for reading in a uniform manner states of
   particle arrays and external systems from 
   PaLa 'movie'-files (PaDyAn 'movie'-files before )

*/
#include <cpmbody.h>
#include <cpmsys2dat.h>
#include <cpmpardynsys.h>
#include <cpmfile.h>

#if defined(CPM_DIMDEF2)

#define CPM_DIM CpmDim2
#define CPM_CAMERA CpmCamera2
#define CPM_RIGID_BODY CpmRigidBody2
#define CPM_PHYSICS CpmPhysics2
#define CPM_TOP CpmPala2_2

namespace CPM_TOP{
   #include <cpmextractorx.h>
}

#undef CPM_DIM
#undef CPM_CAMERA
#undef CPM_PHYSICS
#undef CPM_RIGID_BODY
#undef CPM_TOP

#endif

////////////////////////////////////////////////////////////////

#if defined(CPM_DIMDEF3)

#define CPM_DIM CpmDim3
#define CPM_CAMERA CpmCamera3
#define CPM_RIGID_BODY CpmRigidBody3
#define CPM_PHYSICS CpmPhysics3
#define CPM_TOP CpmPala2_3

namespace CPM_TOP{ 
   #include <cpmextractorx.h>
}

#undef CPM_DIM
#undef CPM_CAMERA
#undef CPM_PHYSICS
#undef CPM_RIGID_BODY
#undef CPM_TOP

#endif

#endif // guard
