//? cpmpardynsys.cpp
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#include <cpmpardynsys.h>

using namespace CpmRoot;

void CpmDynSys::aux::adjust_dt(R& dt, Z counter)
{
   const R incr1=2;
   const R incr2=cpmsqrt(incr1);
   const R incr1Inv=R(1)/incr1;
   const R incr2Inv=R(1)/incr2;

   if (counter<=1) dt*=incr1;
   else if (counter==2) dt*=incr2;
   else if (counter<=4) ;
   else if (counter<=8) dt*=incr2Inv;
   else  dt*=incr1Inv;
}

R CpmDynSys::aux::log10s(R const& x)
{
   R lx=cpmlog10(x);
   return R1(lx).isVal() ? lx : 0.;
}
