//? vqm2.h
//? C+- by Ulrich Mutze. Status of work 2018-12-01.
//? Copyright (c) 2016 Ulrich Mutze
//? contact: see contact-info at www.ulrichmutze.de
//? 
//? This program is free software: you can redistribute it and/or
//? modify it under the terms of the GNU General Public License as
//? published by the Free Software Foundation, either version 3 of
//? the License, or (at your option) any later version.
//? 
//? This program is distributed in the hope that it will be useful,
//? but WITHOUT ANY WARRANTY; without even the implied warranty of
//? MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//? GNU General Public License <http://www.gnu.org/licenses/> for 
//? more details.


#ifndef VQM2_H_
#define VQM2_H_

/*******************************************************************
   vqm2.h

   Description: Rather general structure for a program
      capable of calling various sub-programs
      Here: VQM2 = Visual Quantum Mechanics 2

   History: 02-11-30 length limitation of application lists
      overcome in an elegant manner

********************************************************************/
#include <cpmtypes.h>
#include <cpmv.h>

namespace CpmVQM2{

using CpmArrays::V;
using CpmRoot::Word;
using CpmRootX::fpVoidToVoid;

// functions to be called
void app1();
void app2();
void app3();
void app4();
void app4b();
void app4c();
void app5();
void app6();
void app6b();
void app7();
void app8();
void app9();
void app10();
void app11();
void app12();
void app13();
void app14();
void app15();
void app16();
void app17();
void app18();
void app19();


const Word proTit("vqm2");
   // program title

const V<fpVoidToVoid> appList{app1,app2,app3,app4,app4b,app4c,app5,
   app6,app6b,app7,app8,app9,app10,app11,app12,app13,app14,
   app17,app18,app19};
   // A list of functions

const V<Word> namList{"app1","app2","app3","app4","app4b","app4c",
      "app5", "app6", "app6b","app7","app8","app9","app10","app11",
      "app12","app13","app14","app17","app18","app19"};
   // A list of corresponding function names

} // namespace

#endif
